package command.engine;
import java.util.ArrayList;

import exception.ArgumentMismatchException;
import exception.UnknownCommandTypeException;

public interface EngineCommandFactory {
	
	public Move createMove(ArrayList<Object> args) throws ArgumentMismatchException;
	
	public On createOn(ArrayList<Object> args) throws ArgumentMismatchException;
	
	public Off createOff(ArrayList<Object> args) throws ArgumentMismatchException;
	
	//Abstraction Break Command 
	public SpecificCommand createSpecificCommand(ArrayList<Object> args) throws ArgumentMismatchException ;
	
	public EngineCommand createCommand(VirtualEngineCommand cmd, ArrayList<Object> args) throws ArgumentMismatchException, UnknownCommandTypeException;

}
