package command.engine;

import java.util.ArrayList;

import exception.ArgumentMismatchException;
import exception.UnknownCommandTypeException;

public interface EngineQueryFactory {
	
	public Battery createBattery(ArrayList<Object> args) throws ArgumentMismatchException;
	
	public Speed createSpeed(ArrayList<Object> args) throws ArgumentMismatchException;
	
	public Direction createDirection(ArrayList<Object> args) throws ArgumentMismatchException;

	public SpecificQuery createSpecificQuery(ArrayList<Object> args) throws ArgumentMismatchException;
	
	public EngineQuery createQuery(VirtualEngineQuery q, ArrayList<Object> args) throws ArgumentMismatchException, UnknownCommandTypeException;
}
