package command.engine.md25;

import module.engine.Engine;
import module.engine.md25.MD25EngineInstruction;
import module.engine.md25.MD25EngineTranslator;
import exception.QueryFailureException;
import exception.UnsupportedQueryException;

public class MD25Battery implements command.engine.Battery {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3223654157470294599L;

	@Override
	public double execute(Engine engine) throws QueryFailureException,UnsupportedQueryException {
		try {
			MD25EngineInstruction i = MD25EngineInstruction.GETVOLTS;
			engine.send(MD25EngineTranslator.makeCmd(i, null));
			byte[] ans = engine.receive(MD25EngineTranslator.getRetSize(i));
			return MD25EngineTranslator.answer2double(i, ans);
		} catch (Exception e) {
			throw new QueryFailureException(this.getClass().getName(),e);
		}
	}

}
