package command.engine.md25;

import module.engine.Engine;
import module.engine.md25.MD25EngineTranslator;
import exception.CommunicationException;
import exception.QueryFailureException;
import exception.UnsupportedQueryException;

public class MD25SpecificQuery implements command.engine.SpecificQuery {
	
	byte[] query;
	/**
	 * 
	 */
	private static final long serialVersionUID = 8402074527546893414L;

	public MD25SpecificQuery(byte[] q) {
		query = q;
	}

	@Override
	public double execute(Engine engine) throws QueryFailureException,UnsupportedQueryException {
		try {
			engine.send(query);
			byte[] ans = engine.receive(8);
			return MD25EngineTranslator.answer2double(ans);
		} catch (CommunicationException e) {
			throw new QueryFailureException(this.getClass().getName(),e);
		}
	}
}

