package command.engine.md25;

import module.engine.Engine;
import module.engine.md25.MD25EngineInstruction;
import module.engine.md25.MD25EngineTranslator;
import command.engine.Speed;
import exception.QueryFailureException;
import exception.UnsupportedQueryException;

public class MD25Speed implements Speed {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3068998892123785462L;

	@Override
	public double execute(Engine engine) throws QueryFailureException,UnsupportedQueryException {
		try {
			byte[] ans;
			MD25EngineInstruction i1 = MD25EngineInstruction.GETSPEED1;
			engine.send(MD25EngineTranslator.makeCmd(i1, null));
			ans = engine.receive(MD25EngineTranslator.getRetSize(i1));
			double speed1 = MD25EngineTranslator.answer2double(i1, ans);
			
			MD25EngineInstruction i2 = MD25EngineInstruction.GETSPEED2;
			engine.send(MD25EngineTranslator.makeCmd(i2, null));
			ans = engine.receive(MD25EngineTranslator.getRetSize(i2));
			double speed2 = MD25EngineTranslator.answer2double(i2, ans);
			
			return speed1 > speed2 ? speed2 : speed1;		
		} catch (Exception e) {
			throw new QueryFailureException(this.getClass().getName(),e);
		}
	}

}
