package controller;

import java.util.ArrayList;
import java.util.List;
import util.CommunicationOptions;
import dto.Synchronized;
import dto.communication.ServerInputDTO;
import dto.communication.ServerOutputDTO;
import module.IndependentModule;
import module.communication.Server;

public abstract class MasterController extends Controller {
	protected Synchronized<ServerInputDTO> Soutput = new Synchronized<ServerInputDTO>(new ServerInputDTO());
	protected Synchronized<ServerOutputDTO> Sinput = new Synchronized<ServerOutputDTO>(new ServerOutputDTO());
	protected Server server;

	@Override
	protected List<IndependentModule<?, ?>> createModules() {
		List<IndependentModule<?, ?>> ret = new ArrayList<IndependentModule<?, ?>>();
		ret.add(server);
		return ret;
	}

	@Override
	protected void stopModules() {
		ServerInputDTO Si = new ServerInputDTO();
		Si.kill=true;
		Soutput.write(Si);
	}

	/*
	 * This method is only a stub. It should be overridden in descendant classes.
	 * @see controller.Controller#control()
	 */
	@Override
	protected void control() throws Exception {
		ServerOutputDTO report = Sinput.read();
		if(report.updated) {
			checkStatus(report, true);
			if(CommunicationOptions.slave!=null) {
				ServerInputDTO Si = new ServerInputDTO();			
				Si.message = "Hello World!".getBytes();
				Si.receiver = CommunicationOptions.slave;
				Soutput.write(Si);
				System.out.println("Sent to : " + CommunicationOptions.slave + "the following message: \"Hello World!\"");
			}
		}
	}



}
