package controller;

import java.util.ArrayList;
import java.util.List;
import util.TypeUtil;
import dto.Synchronized;
import dto.communication.ClientInputDTO;
import dto.communication.ClientOutputDTO;
import module.IndependentModule;
import module.communication.Client;

public class SlaveController extends Controller {
	protected Synchronized<ClientInputDTO> Coutput = new Synchronized<ClientInputDTO>(new ClientInputDTO());
	protected Synchronized<ClientOutputDTO> Cinput = new Synchronized<ClientOutputDTO>(new ClientOutputDTO());
	protected Client client;

	@Override
	protected List<IndependentModule<?, ?>> createModules() {
		List<IndependentModule<?, ?>> ret = new ArrayList<IndependentModule<?, ?>>();
		ret.add(client);
		return ret;
	}

	@Override
	protected void stopModules() {
		ClientInputDTO Ci = new ClientInputDTO();
		Ci.kill=true;
		Coutput.write(Ci);
	}

	/*
	 * This method is only a stub. It should be overridden in descendant classes.
	 * @see controller.Controller#control()
	 */
	@Override
	protected void control() throws Exception {
		ClientOutputDTO report = Cinput.read();
		if(report.updated) {
			checkStatus(report, true);
			Object obj = TypeUtil.byte2object(report.message);
			if(obj != null)
				System.out.println(report.sender + " has sent an object of type: " + obj.getClass().getName());
			else System.out.println(report.sender + " has sent the following message: \"" + new String(report.message)+"\"");
		}
	}

}
