package controller.interpreter;

import util.TypeUtil;
import module.communication.Client;
import module.engine.Engine;
import dto.communication.ClientOutputDTO;
import dto.engine.EngineInputDTO;

public class CommEngInterpreter extends Interpreter<EngineInputDTO,ClientOutputDTO,Client,Engine>{

	public CommEngInterpreter(Client interpretedModule, Engine instructedModule) {
		super(interpretedModule, instructedModule);
	}

	@Override
	public EngineInputDTO interpret(ClientOutputDTO input) throws Exception {
		
		EngineInputDTO dto;
		
		//for more security there should be a verification here using input.sender, verifying if it's really the slaves master.
		try {
			dto = (EngineInputDTO) TypeUtil.byte2object(input.message);
		}  catch(Exception e) {
			return null;
		}
		return dto;
	}

	@Override
	public EngineInputDTO followUp() throws Exception {
		return null;
	}

}
