package controller.interpreter;

import module.IndependentModule;
import dto.InputDTO;
import dto.OutputDTO;

public abstract class Interpreter<O extends InputDTO,I extends OutputDTO,MI extends IndependentModule<?,I>,MO extends IndependentModule<O,?>> {
	protected MI interpretedModule;
	protected MO instructedModule;

	public Interpreter(MI interpretedModule,MO instructedModule) {
		this.interpretedModule = interpretedModule;
		this.instructedModule = instructedModule;
	}

	public abstract O interpret(I input) throws Exception;
	public abstract O followUp() throws Exception;
	
}
