package module.communication;

import util.FrequencyOptions;
import module.IndependentModule;
import dto.Synchronized;
import dto.communication.ClientInputDTO;
import dto.communication.ClientOutputDTO;
import exception.ClientFailureException;

public abstract class Client extends IndependentModule<ClientInputDTO,ClientOutputDTO> {
	protected int port;
	
	protected Client(Synchronized<ClientInputDTO> input, Synchronized<ClientOutputDTO> output, int port) {
		super(input, output);
		this.port=port;
	}
	
	@Override
	protected abstract void perceive() throws ClientFailureException;
	
	@Override
	protected void act() {};
	
	@Override
	public long getPeriod() {
		return FrequencyOptions.CommunicationClientPeriod;
	};
	
}