package module.communication;

import util.FrequencyOptions;
import dto.Synchronized;
import dto.communication.ServerInputDTO;
import dto.communication.ServerOutputDTO;
import exception.ServerFailureException;

import module.IndependentModule;

public abstract class Server extends IndependentModule<ServerInputDTO,ServerOutputDTO> {
	protected int port;
	
	protected Server(Synchronized<ServerInputDTO> input,Synchronized<ServerOutputDTO> output, int port) {
		super(input, output);
		this.port=port;
	}

	@Override
	protected abstract void act() throws ServerFailureException;
	
	@Override
	protected void perceive() {};
	
	@Override
	public long getPeriod() {
		return FrequencyOptions.CommunicationServerPeriod;
	};


}
