package module.communication.udp;

import java.io.IOException;
import java.net.DatagramSocket;
import java.net.SocketException;

import module.communication.Server;
import dto.Synchronized;
import dto.communication.ServerInputDTO;
import dto.communication.ServerOutputDTO;
import exception.ServerFailureException;
import util.SocketUtil;
import util.VisibilityOptions;

public class UDPServer extends Server {
	private DatagramSocket udpS;

	public UDPServer(Synchronized<ServerInputDTO> input, Synchronized<ServerOutputDTO> output,int port) {
		super(input, output,port);
	}

	@Override
	protected void act() throws ServerFailureException {
		try {
			if(instructions.message == null) {
				if(VisibilityOptions.verbose) System.out.println("Packet could not be transmitted.");
			}
			else SocketUtil.send(udpS,instructions.message,instructions.receiver);
		} catch (IOException e) {
			throw new ServerFailureException("port - "+port,e);
		}
	}
	
	@Override
	protected void start() throws Exception {
		try {
			udpS = new DatagramSocket(port);
		} catch (SocketException e) {
			throw new ServerFailureException("port - "+port,e);
		}
		on=true;
	}
	
	@Override
	protected void stop() throws Exception {
		udpS.close();
		on=false;
	}
	

}
