package util;

public class ParsingUtil {

	public static int parseArgs(String[] args) {
		
		if(args.length > 0) {
			char[] arg0_chars = args[0].toCharArray();
			if (arg0_chars.length > 0) {
				if (arg0_chars[0] == '-') {
					if (arg0_chars.length > 1) {
						int index = 1;
						for (int i = 1; i < arg0_chars.length; i++) {
							if (arg0_chars[i] == 'i') {
								if (args.length > index - 1) {
									try {
										int camID = Integer.parseInt(args[index]);
										VisionOptions.camID = camID;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'T') {
								if (args.length > index - 1) {
									try {
										int threshold = Integer.parseInt(args[index]);
										VisionOptions.threshold = threshold;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'V') {
								if (args.length > index - 1) {
									try {
										int maxValue = Integer.parseInt(args[index]);
										VisionOptions.imgMaxValue = maxValue;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'A') {
								if (args.length > index - 1) {
									try {
										int maxArea = Integer.parseInt(args[index]);
										VisionOptions.MaxArea= maxArea;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'm') {
								if (args.length > index - 1) {
									CommunicationOptions.masterNamesFile = args[index];
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'l') {
								if (args.length > index - 1) {
									CommunicationOptions.slaveNamesFile = args[index];
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 's') {
								if (args.length > index - 1) {
									try {
										int server_port = Integer.parseInt(args[index]);
										CommunicationOptions.serverPort = server_port;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'c') {
								if (args.length > index - 1) {
									try {
										int client_port = Integer.parseInt(args[index]);
										CommunicationOptions.clientPort = client_port;
									} catch (NumberFormatException e) {
										return -1;
									}
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'b') {
								if (args.length > index - 1) {
									CommunicationOptions.slave = args[index];
									index++;
								} else
									return -1;
							} else if (arg0_chars[i] == 'v') {
								VisibilityOptions.verbose = true;
							} else if (arg0_chars[i] == 'd') {
								VisibilityOptions.debug = true;
							} else if (arg0_chars[i] == 'w') {
								VisibilityOptions.show_windows = true;
							} else if (arg0_chars[i] == 'a') {
								VisibilityOptions.draw_all_centroids = true;
							} else if (arg0_chars[i] == 'f') {
								VisibilityOptions.print_fps = true;
							} else if (arg0_chars[i] == 'r') {
								CommunicationOptions.remoteOnly = true;
							} else {
								return -1;
							}
						}
					} else {
						return -1;
					}
				} else {
					return -1;
				}
			}
		}
		return 0;
	}
	
	public static void printHelp(String controllerName) {
		System.out.println("Usage: ");
		System.out.print("java -jar " + controllerName + ".jar ");
		if (controllerName.equals("WebCamMaster")) {
			System.out.println("[-options] [camera_id] [threshold] [max_value] [max_area] [masters_file] [slaves_file] [server_port] [slave]\n");
			System.out.println("where options include:\n");
			System.out.println("\ti\t[camera_id]\targ is specified");
			System.out.println("\tT\t[threshold]\targ is specified");
			System.out.println("\tV\t[max_value]\targ is specified");
			System.out.println("\tA\t[max_area]\targ is specified");
			System.out.println("\tm\t[masters_file]\targ is specified");
			System.out.println("\tl\t[slaves_file]\targ is specified");
			System.out.println("\ts\t[server_port]\targ is specified");
			System.out.println("\tb\t[slave]\t\targ is specified\n");
			System.out.println("\tif any of the above flags are included, you need to specify the correspondent argument");
			System.out.println("\tin the order flags are concatenated\n");
			System.out.println("\tv\tenable verbose output");
			System.out.println("\td\tenable more detailed verbose output (prints exception traces)");
			System.out.println("\tw\tshows original and black&white camera image windows");
			System.out.println("\ta\tdraws all centroids computed in the black&white camera image window");
			System.out.println("\tf\tprints camera's frame rate\n");
			System.out.println("[camera_id]\tspecifies the number associated with the camera device path to capture (/dev/video<camera_id>)\n");
			System.out.println("[theshold]\tspecifies the threshold value to compute the b&w image");
			System.out.println("[max_value]\tspecifies the value to assign if pixel value is under threshold");
			System.out.println("[max_area]\tmaximum area to compute centroid");
			System.out.println("[masters_file]\tspecifies the server's communication configurations file\n");
			System.out.println("[slaves_file]\tspecifies the client's communication configurations file\n");
			System.out.println("[server_port]\tspecifies the port through which server sends messages\n");
			System.out.println("[slave]\t\tspecifies the slave to command. Can either be the IP address of a particular slave or \"BROADCAST\" string to command all of them\n");
		}
		else if(controllerName.equals("KeyboardMaster")) {
			System.out.println("[-options] [masters_file] [slaves_file] [server_port] [slave]\n");
			System.out.println("where options include:\n");
			System.out.println("\tm\t[masters_file]\targ is specified");
			System.out.println("\tl\t[slaves_file]\targ is specified");
			System.out.println("\ts\t[server_port]\targ is specified");
			System.out.println("\tb\t[slave]\t\targ is specified\n");
			System.out.println("\tif any of the above flags are included, you need to specify the correspondent argument");
			System.out.println("\tin the order flags are concatenated\n");
			System.out.println("\tv\tenable verbose output");
			System.out.println("\td\tenable more detailed verbose output (prints exception traces)");
			System.out.println("\tr\tonly remote slaves are commanded\n");
			System.out.println("[masters_file]\tspecifies the server's communication configurations file\n");
			System.out.println("[slaves_file]\tspecifies the client's communication configurations file\n");
			System.out.println("[server_port]\tspecifies the port through which server sends messages\n");
			System.out.println("[slave]\t\tspecifies the slave to command. Can either be the IP address of a particular slave or \"BROADCAST\" to command all of them\n");
		}
		else if(controllerName.equals("Slave")) {
			System.out.println("[-options] [masters_file] [client_port]\n");
			System.out.println("where options include:\n");
			System.out.println("\tm\t[masters_file]\targ is specified");
			System.out.println("\tc\t[client_port]\targ is specified\n");
			System.out.println("\tif any of the above flags are included, you need to specify the correspondent argument");
			System.out.println("\tin the order flags are concatenated\n");
			System.out.println("\tv\tenable verbose output");
			System.out.println("\td\tenable more detailed verbose output (prints exception traces)");
			System.out.println("[masters_file]\tspecifies the server's communication configurations file\n");
			System.out.println("[client_port]\tspecifies the port through which client sends messages\n");
		}
		System.exit(-1);
	}
}
