package util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.nio.ByteBuffer;

public class TypeUtil {
	
	public static double byte2double(byte[] b) {
		ByteBuffer buf = ByteBuffer.wrap(b);
		return Double.longBitsToDouble(buf.getLong());	
	}
	
	public static byte[] double2byte(double d) {
		ByteBuffer buf = ByteBuffer.wrap(new byte[8]);
		buf.putLong(Double.doubleToLongBits(d));
		return buf.array();	
	}

	public static Object byte2object(byte[] bytes) {
		try {
			ByteArrayInputStream bas = new ByteArrayInputStream(bytes);
			ObjectInputStream in = new ObjectInputStream(bas);
			Object obj = in.readObject();
			in.close();
			bas.close();
			return obj;
		} catch (Exception e) {	return null; }
	}
	
	public static byte[] object2byte(Object obj) {
		try {
			ByteArrayOutputStream bas = new ByteArrayOutputStream();
			ObjectOutputStream out = new ObjectOutputStream(bas);
			out.writeObject(obj);
			byte[] bytes = bas.toByteArray();
			out.flush();
			out.close();
			bas.close();
			return bytes;
		} catch(Exception e) { return null; }
	}
	
}
